package cokr.xit.fims.sndb.service.bean;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CmmnUtil;
import cokr.xit.fims.sndb.SndbQuery;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.fims.sndb.Svbtc;
import cokr.xit.fims.sndb.dao.SndngDtlMapper;
import cokr.xit.fims.sndb.dao.SvbtcMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**공시송달 대장 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-01-09	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("svbtcBean")
public class SvbtcBean extends AbstractBean {

	/** 공시송달 대장 정보 DAO */
	@Resource(name = "svbtcMapper")
	private SvbtcMapper svbtcMapper;

	/** 발송 상세 정보 DAO */
	@Resource(name = "sndngDtlMapper")
	private SndngDtlMapper sndngDtlMapper;

	/**지정한 조건에 따라 공시송달 대장 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 목록
	 */
	public List<DataObject> getSvbtcList(SndbQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			if (req.getBy() == null) {
				req.setOrderBy("REG_DT");
			} else {
				req.setOrderBy(CmmnUtil.convertCamelCaseToSnakeCase(req.getBy()));
			}
		}

		return svbtcMapper.selectSvbtcList(req);
	}

	/**지정한 조건에 따라 공시송달 대장 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public List<DataObject> getSvbtcs(SndbQuery req) {
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		if (req.getOrderBy() == null) {
			req.setOrderBy("SV.SVBTC_ID");
		}

		return svbtcMapper.selectSvbtcs(req);
	}

	/**지정한 조건에 따라 공시송달 대장 객체의 마지막 1개를 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public DataObject getSvbtcInfo(SndbQuery req) {
        return svbtcMapper.selectSvbtcInfo(req);
    }

	/**지정한 조건에 따라 공시송달 상세 목록을 조회하여 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public List<DataObject> getSvbtcDtlList(SndbQuery req) {
		return svbtcMapper.selectSvbtcDtlList(req);
	}

	/**지정한 조건에 따라 공시송달 상세 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public List<DataObject> getSvbtcDtls(SndbQuery req) {
		return svbtcMapper.selectSvbtcDtls(req);
	}

	/**지정한 조건에 따라 공시송달 상세 객체들을 반환한다.
	 * @param req 공시송달 대장 조회 조건
	 * @return 공시송달 대장 객체 목록
	 */
	public List<DataObject> getSvbtcPrint(SndbQuery req) {
		return svbtcMapper.selectSvbtcPrint(req);
	}

	/**공시송달 대장 정보를 등록한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String createSvbtc(SndbQuery req, Svbtc svbtc) {
		// 변수 선언
		int rtnNocs = -1;														// 처리 결과 건수

		// 공시송달(TB_SNDNG_DTL) 대장에 공시송달 정보를 등록한다.
		rtnNocs = svbtcMapper.insertSvbtc(svbtc);
		if (rtnNocs != 1) {
			throw new RuntimeException("공시송달 정보 등록에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		List<DataObject> sndngDtlList = new ArrayList<DataObject>();
		if (svbtc.getSndngDtlIds() == null || svbtc.getSndngDtlIds().length < 1) {
			req.setOrderBy("SD.SNDNG_DTL_ID");

			sndngDtlList = sndngDtlMapper.selectSvbtcsTrgtSndngDtlIds(req);
		} else {
			SndbQuery query = new SndbQuery();
			query.setSndngDtlIds(svbtc.getSndngDtlIds());
			query.setOrderBy("SD.SNDNG_DTL_ID");

			sndngDtlList = sndngDtlMapper.selectSvbtcsTrgtSndngDtlIds(query);
		}

        // 공시송달 정보 수정
		for (int iLoop = 0; iLoop < sndngDtlList.size(); iLoop++) {
			// 발송 상세
			SndngDtl sndngDtl = new SndngDtl();
			sndngDtl.setSvbtcId(svbtc.getSvbtcId());
			sndngDtl.setSndngDtlSttsCd("06");
			sndngDtl.setSndngDtlId(sndngDtlList.get(iLoop).string("SNDNG_DTL_ID"));

			// 발송 상세(TB_SNDNG_DTL) 대장에 공시송달 정보를 등록한다.
			rtnNocs = sndngDtlMapper.updateSndngDtlSvbtc(sndngDtl);
			if (rtnNocs != 1) {
				throw new RuntimeException("발송상세 대장에 공시송달 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
			}
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**공시송달 대장 정보를 수정한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String updateSvbtc(Svbtc svbtc) {
		// 공시송달(TB_SVBTC) 정보를 수정한다.
		int rtnNocs = svbtcMapper.updateSvbtc(svbtc);
		if (rtnNocs != 1) {
			throw new RuntimeException("공시송달 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**공시송달 대장 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String removeSvbtc(Svbtc svbtc) {
		// 변수 선언
		int rtnNocs = -1;														// 처리 결과 건수
		String rtnMsg = "";														// 처리 결과 메시지

		// 공시송달(TB_SVBTC) 정보를 조회한다.
		DataObject svbtcInfo = svbtcMapper.selectSvbtcInfo(new SndbQuery().setSvbtcId(svbtc.getSvbtcId()));

		// 삭제 대상 자료 ID 확인
		if (svbtcInfo.string("SVBTC_ID").equals("")) {
			rtnMsg = "[F] 작업 중 오류가 발생하였습니다.<br>공시송달 대장 자료가 존재하지 않습니다.";
			return rtnMsg;
		}

		// 공시송달(TB_SVBTC) 대장을 삭제한다.
		rtnNocs = svbtcMapper.deleteSvbtc(svbtc);
		if (rtnNocs != 1) {
			throw new RuntimeException("공시송달 대장 삭제에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}

		SndngDtl sndngDtl = new SndngDtl();
		sndngDtl.setSndngDtlIds(svbtc.getSndngDtlIds());
		sndngDtl.setSvbtcId(svbtc.getSvbtcId());
		sndngDtl.setSndngDtlSttsCd("05");

		// 발송 상세(TB_SNDNG_DTL) 대장에서 공시송달 정보를 삭제한다.
		rtnNocs = sndngDtlMapper.deleteSndngDtlSvbtc(sndngDtl);
		if (rtnNocs < 1) {
			throw new RuntimeException("발송상세 대장에 공시송달 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
		}
		if (toInt(svbtcInfo.get("TNOCS")) != rtnNocs) {
			throw new RuntimeException("공시송달 총건수와 발송상세 건수가 다릅니다.");	// 예외를 발생시켜서 DB Rollback
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

	/**공시송달 대장 정보를 삭제한다.
	 * @param svbtc 공시송달 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public String removeSvbtcEach(Svbtc svbtc) {
		// 변수 선언
		int rtnNocs = -1;														// 처리 결과 건수
		String rtnMsg = "";														// 처리 결과 메시지

		// 공시송달(TB_SVBTC) 정보를 조회한다.
		DataObject svbtcInfo = svbtcMapper.selectSvbtcInfo(new SndbQuery().setSvbtcId(svbtc.getSvbtcId()));

		// 삭제 대상 자료 ID 확인
		if (svbtcInfo.string("SVBTC_ID").equals("")) {
			rtnMsg = "[F] 작업 중 오류가 발생하였습니다.<br>공시송달 대장 자료가 존재하지 않습니다.";
			return rtnMsg;
		}

		// 총건수
		int trgtNocs = toInt(svbtcInfo.get("TNOCS")) - svbtc.getSndngDtlIds().length;
		if (trgtNocs == 0) {													// 전체 삭제
			rtnMsg = removeSvbtc(svbtc);
			if (!rtnMsg.contains("[S]")) {										// 오류가 발생하였으면 종료..
				throw new RuntimeException(rtnMsg.replace("[F]", ""));			// 예외를 발생시켜서 DB Rollback
			}
		} else if (trgtNocs >= 1) {												// 일부 삭제
			SndngDtl sndngDtl = new SndngDtl();
			sndngDtl.setSndngDtlIds(svbtc.getSndngDtlIds());
			sndngDtl.setSvbtcId(svbtc.getSvbtcId());
			sndngDtl.setSndngDtlSttsCd("05");

			// 발송 상세(TB_SNDNG_DTL) 대장에서 공시송달 정보를 삭제한다.
			rtnNocs = sndngDtlMapper.deleteSndngDtlSvbtc(sndngDtl);
			if (rtnNocs < 1) {
				throw new RuntimeException("발송 상세 대장에 공시송달 정보 수정에 실패하였습니다.");	// 예외를 발생시켜서 DB Rollback
			}

			Svbtc updtSvbtc = new Svbtc();
			updtSvbtc.setSvbtcYmd(svbtcInfo.string("SVBTC_YMD"));				// 공시송달 일자
			updtSvbtc.setSvbtcEndYmd(svbtcInfo.string("SVBTC_END_YMD"));		// 공시송달 종료 일자
			updtSvbtc.setTtlNm(svbtcInfo.string("TTL_NM"));						// 제목 명
			updtSvbtc.setDocNo(svbtcInfo.string("DOC_NO"));						// 문서 번호
			updtSvbtc.setEtcCn(svbtcInfo.string("ETC_CN"));						// 기타 내용
			updtSvbtc.setTnocs(trgtNocs);										// 총건수
			updtSvbtc.setSvbtcId(svbtc.getSvbtcId());

			// 공시송달(TB_SVBTC) 정보를 수정한다.
			rtnMsg = updateSvbtc(updtSvbtc);
			if (!rtnMsg.contains("[S]")) {										// 오류가 발생하였으면 종료..
				throw new RuntimeException(rtnMsg.replace("[F]", ""));			// 예외를 발생시켜서 DB Rollback
			}
		} else {
			throw new RuntimeException("공시송달 총건수 보다 선택건수가 많이 조회됩니다.");
		}

		return "[S] 작업이 정상 처리 되었습니다.";
	}

}
